// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: battle.proto
// </auto-generated>
#pragma warning disable 0414, 1591
#region Designer generated code

using grpc = global::Grpc.Core;

namespace Battle {
  public static partial class BattleService
  {
    static readonly string __ServiceName = "battle.BattleService";

    static void __Helper_SerializeMessage(global::Google.Protobuf.IMessage message, grpc::SerializationContext context)
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (message is global::Google.Protobuf.IBufferMessage)
      {
        context.SetPayloadLength(message.CalculateSize());
        global::Google.Protobuf.MessageExtensions.WriteTo(message, context.GetBufferWriter());
        context.Complete();
        return;
      }
      #endif
      context.Complete(global::Google.Protobuf.MessageExtensions.ToByteArray(message));
    }

    static class __Helper_MessageCache<T>
    {
      public static readonly bool IsBufferMessage = global::System.Reflection.IntrospectionExtensions.GetTypeInfo(typeof(global::Google.Protobuf.IBufferMessage)).IsAssignableFrom(typeof(T));
    }

    static T __Helper_DeserializeMessage<T>(grpc::DeserializationContext context, global::Google.Protobuf.MessageParser<T> parser) where T : global::Google.Protobuf.IMessage<T>
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (__Helper_MessageCache<T>.IsBufferMessage)
      {
        return parser.ParseFrom(context.PayloadAsReadOnlySequence());
      }
      #endif
      return parser.ParseFrom(context.PayloadAsNewBuffer());
    }

    static readonly grpc::Marshaller<global::Battle.Battle> __Marshaller_battle_Battle = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Battle.Battle.Parser));
    static readonly grpc::Marshaller<global::Common.BattleId> __Marshaller_common_BattleId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.BattleId.Parser));
    static readonly grpc::Marshaller<global::Common.UserId> __Marshaller_common_UserId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.UserId.Parser));
    static readonly grpc::Marshaller<global::Battle.BattleList> __Marshaller_battle_BattleList = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Battle.BattleList.Parser));
    static readonly grpc::Marshaller<global::Battle.BattleRequest> __Marshaller_battle_BattleRequest = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Battle.BattleRequest.Parser));
    static readonly grpc::Marshaller<global::Battle.ResponseStatus> __Marshaller_battle_ResponseStatus = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Battle.ResponseStatus.Parser));
    static readonly grpc::Marshaller<global::Battle.Command> __Marshaller_battle_Command = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Battle.Command.Parser));

    static readonly grpc::Method<global::Battle.Battle, global::Common.BattleId> __Method_AddBattle = new grpc::Method<global::Battle.Battle, global::Common.BattleId>(
        grpc::MethodType.Unary,
        __ServiceName,
        "AddBattle",
        __Marshaller_battle_Battle,
        __Marshaller_common_BattleId);

    static readonly grpc::Method<global::Common.BattleId, global::Battle.Battle> __Method_getBattleByID = new grpc::Method<global::Common.BattleId, global::Battle.Battle>(
        grpc::MethodType.Unary,
        __ServiceName,
        "getBattleByID",
        __Marshaller_common_BattleId,
        __Marshaller_battle_Battle);

    static readonly grpc::Method<global::Common.UserId, global::Battle.BattleList> __Method_GetBattleByUserID = new grpc::Method<global::Common.UserId, global::Battle.BattleList>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetBattleByUserID",
        __Marshaller_common_UserId,
        __Marshaller_battle_BattleList);

    static readonly grpc::Method<global::Battle.BattleRequest, global::Battle.ResponseStatus> __Method_StartBattle = new grpc::Method<global::Battle.BattleRequest, global::Battle.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "StartBattle",
        __Marshaller_battle_BattleRequest,
        __Marshaller_battle_ResponseStatus);

    static readonly grpc::Method<global::Battle.Battle, global::Common.BattleId> __Method_AddTestBattle = new grpc::Method<global::Battle.Battle, global::Common.BattleId>(
        grpc::MethodType.Unary,
        __ServiceName,
        "AddTestBattle",
        __Marshaller_battle_Battle,
        __Marshaller_common_BattleId);

    static readonly grpc::Method<global::Battle.Command, global::Battle.ResponseStatus> __Method_CommandRequest = new grpc::Method<global::Battle.Command, global::Battle.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "CommandRequest",
        __Marshaller_battle_Command,
        __Marshaller_battle_ResponseStatus);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Battle.BattleReflection.Descriptor.Services[0]; }
    }

    /// <summary>Base class for server-side implementations of BattleService</summary>
    [grpc::BindServiceMethod(typeof(BattleService), "BindService")]
    public abstract partial class BattleServiceBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Common.BattleId> AddBattle(global::Battle.Battle request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Battle.Battle> getBattleByID(global::Common.BattleId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Battle.BattleList> GetBattleByUserID(global::Common.UserId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Battle.ResponseStatus> StartBattle(global::Battle.BattleRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.BattleId> AddTestBattle(global::Battle.Battle request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Battle.ResponseStatus> CommandRequest(global::Battle.Command request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for BattleService</summary>
    public partial class BattleServiceClient : grpc::ClientBase<BattleServiceClient>
    {
      /// <summary>Creates a new client for BattleService</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public BattleServiceClient(grpc::ChannelBase channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for BattleService that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public BattleServiceClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected BattleServiceClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected BattleServiceClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Common.BattleId AddBattle(global::Battle.Battle request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddBattle(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.BattleId AddBattle(global::Battle.Battle request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_AddBattle, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.BattleId> AddBattleAsync(global::Battle.Battle request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddBattleAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.BattleId> AddBattleAsync(global::Battle.Battle request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_AddBattle, null, options, request);
      }
      public virtual global::Battle.Battle getBattleByID(global::Common.BattleId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return getBattleByID(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Battle.Battle getBattleByID(global::Common.BattleId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_getBattleByID, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Battle.Battle> getBattleByIDAsync(global::Common.BattleId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return getBattleByIDAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Battle.Battle> getBattleByIDAsync(global::Common.BattleId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_getBattleByID, null, options, request);
      }
      public virtual global::Battle.BattleList GetBattleByUserID(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetBattleByUserID(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Battle.BattleList GetBattleByUserID(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetBattleByUserID, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Battle.BattleList> GetBattleByUserIDAsync(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetBattleByUserIDAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Battle.BattleList> GetBattleByUserIDAsync(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetBattleByUserID, null, options, request);
      }
      public virtual global::Battle.ResponseStatus StartBattle(global::Battle.BattleRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return StartBattle(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Battle.ResponseStatus StartBattle(global::Battle.BattleRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_StartBattle, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Battle.ResponseStatus> StartBattleAsync(global::Battle.BattleRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return StartBattleAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Battle.ResponseStatus> StartBattleAsync(global::Battle.BattleRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_StartBattle, null, options, request);
      }
      public virtual global::Common.BattleId AddTestBattle(global::Battle.Battle request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddTestBattle(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.BattleId AddTestBattle(global::Battle.Battle request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_AddTestBattle, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.BattleId> AddTestBattleAsync(global::Battle.Battle request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddTestBattleAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.BattleId> AddTestBattleAsync(global::Battle.Battle request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_AddTestBattle, null, options, request);
      }
      public virtual global::Battle.ResponseStatus CommandRequest(global::Battle.Command request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return CommandRequest(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Battle.ResponseStatus CommandRequest(global::Battle.Command request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_CommandRequest, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Battle.ResponseStatus> CommandRequestAsync(global::Battle.Command request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return CommandRequestAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Battle.ResponseStatus> CommandRequestAsync(global::Battle.Command request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_CommandRequest, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override BattleServiceClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new BattleServiceClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(BattleServiceBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_AddBattle, serviceImpl.AddBattle)
          .AddMethod(__Method_getBattleByID, serviceImpl.getBattleByID)
          .AddMethod(__Method_GetBattleByUserID, serviceImpl.GetBattleByUserID)
          .AddMethod(__Method_StartBattle, serviceImpl.StartBattle)
          .AddMethod(__Method_AddTestBattle, serviceImpl.AddTestBattle)
          .AddMethod(__Method_CommandRequest, serviceImpl.CommandRequest).Build();
    }

    /// <summary>Register service method with a service binder with or without implementation. Useful when customizing the  service binding logic.
    /// Note: this method is part of an experimental API that can change or be removed without any prior notice.</summary>
    /// <param name="serviceBinder">Service methods will be bound by calling <c>AddMethod</c> on this object.</param>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static void BindService(grpc::ServiceBinderBase serviceBinder, BattleServiceBase serviceImpl)
    {
      serviceBinder.AddMethod(__Method_AddBattle, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Battle.Battle, global::Common.BattleId>(serviceImpl.AddBattle));
      serviceBinder.AddMethod(__Method_getBattleByID, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.BattleId, global::Battle.Battle>(serviceImpl.getBattleByID));
      serviceBinder.AddMethod(__Method_GetBattleByUserID, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.UserId, global::Battle.BattleList>(serviceImpl.GetBattleByUserID));
      serviceBinder.AddMethod(__Method_StartBattle, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Battle.BattleRequest, global::Battle.ResponseStatus>(serviceImpl.StartBattle));
      serviceBinder.AddMethod(__Method_AddTestBattle, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Battle.Battle, global::Common.BattleId>(serviceImpl.AddTestBattle));
      serviceBinder.AddMethod(__Method_CommandRequest, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Battle.Command, global::Battle.ResponseStatus>(serviceImpl.CommandRequest));
    }

  }
}
#endregion
